clc;
close all;
clear all;

f = 'D:\Destkop\SLC_SDV\test\subset_0_of_subset_9_of_S1A_IW2_SLC__1SDV_20151125T233123_20151125T233136_008768_00C7F0_D298.data';
Column  =279;
Row  = 191;
% HTest=10;
path=strcat(f,'\i_IW2_VH.img');
fid=fopen(path,'rb');
VH_real=fread(fid,[Column,Row],'int16');VH_real=VH_real.';
fclose(fid);
path=strcat(f,'\q_IW2_VH.img');
fid=fopen(path,'rb');
VH_imag=fread(fid,[Column,Row], 'int16');VH_imag=VH_imag.';
fclose(fid);
VHtest=VH_real+1i.*VH_imag;

path=strcat(f,'\i_IW2_VV.img');
fid=fopen(path,'rb');
VV_real=fread(fid,[Column,Row],'int16');VV_real=VV_real.';
fclose(fid);
path=strcat(f,'\q_IW2_VV.img');
fid=fopen(path,'rb');
VV_imag=fread(fid,[Column,Row],'int16');VV_imag=VV_imag.';
fclose(fid);
VVtest=VV_real+1i.*VV_imag;



figure(1);  imshow(abs(VHtest).^2,[]);title('106E-IW2-VH');
figure(2);  imshow(abs(VVtest).^2,[]);title('106E-IW2-VV');
[size_r,size_c]=size(VVtest);


g1=abs(VHtest).^2+abs(VVtest).^2;
g2=abs(VHtest).^2-abs(VVtest).^2;
g3=2*real(VHtest.*conj(VVtest));
g4=2*imag(VHtest.*conj(VVtest));

WinTest=3;
f = fspecial('average', WinTest);
C11 = imfilter(abs(VVtest).^2, f);
C12 = imfilter(VVtest.*conj(VHtest), f);
C21 = imfilter(conj(VVtest).*VHtest, f);
C22 = imfilter(abs(VHtest).^2, f);
g1 = imfilter(g1, f);
g2 = imfilter(g2, f);
g3 = imfilter(g3, f);
g4 = imfilter(g4, f);

% ++++++++++++++++++++++++++++++ Create Coherence +++++++++++++++++++++++++++++++

coherence=(abs(C12)-min(min(abs(C12)))./(max(max(abs(C12)))-min(min(abs(C12)))));
figure (3), imshow(coherence,[]), title('Coherence');

% ++++++++++++++++++++++++++++++ Create Entropy +++++++++++++++++++++++++++++++
C = zeros(2,2); lam1 = zeros(size_r,size_c); lam2 = zeros(size_r,size_c); 
alpha1 = zeros(size_r,size_c); alpha2 = zeros(size_r,size_c);
beta1 = zeros(size_r,size_c); beta2 = zeros(size_r,size_c); 
H = zeros(size_r,size_c);

for m=1:size_r
    for n=1:size_c
        % Pixel by pixel we build the matrix to diagonalise
        C(1,1) = C11(m,n); C(1,2) = C12(m,n); 
        C(2,1) = C21(m,n); C(2,2) = C22(m,n);
        %++++++++++++++++++++++ Diagonalisation %+++++++++++++++++++++++++
        [u,d]=eig(C);
        lam1(m,n) = abs(d(1,1));
        lam2(m,n) = abs(d(2,2));
     
        % Probability of each eigenvalue
        P1 = abs(d(1,1) / (d(1,1) + d(2,2)));
        P2 = abs(d(2,2) / (d(1,1) + d(2,2)));

        % Entropy 
        H(m,n) =  -P1*log10(P1)/log10(3) - P2*log10(P2)/log10(3);

    
    end
end
figure (4), imshow(H,[]), title('Entropy');

% ++++++++++++++++++++++++++++++ Create Degree of Depolarization +++++++++++++++++++
Dp=sqrt(abs(g2).^2+abs(g3).^2+abs(g4).^2)./g1;
DeD=1-Dp;
figure (5), imshow(DeD,[]), title('DeD');

